<?php

namespace App\Services\Part;

use App\Entities\Equipment\ServerPartEntity;
use App\Entities\Part\CSEntity;
use App\Helpers\Part\CSHelper;
use App\Models\Part\CSModel;
use App\Services\Customer\ServiceService;
use App\Services\Equipment\ServerService;

class CSService extends PartService
{
    private ?ServiceService $_serviceService = null;
    private ?ServerService $_serverService = null;
    public function __construct()
    {
        parent::__construct(new CSModel(), new CSHelper());
        $this->addClassName('CS');
    }
    public function getFormFields(): array
    {
        return  [
            "type",
            "ip",
            "accountid",
            "domain",
            "price",
            "status",
        ];
    }
    public function getFormFilters(): array
    {
        return [
            "clientinfo_uid",
            'serverinfo_uid',
            'type',
            'status'
        ];
    }
    public function getIndexFields(): array
    {
        return [
            "clientinfo_uid",
            'serverinfo_uid',
            'type',
            'ip',
            'accountid',
            'domain',
            'price',
            'status',
        ];
    }
    public function getBatchjobFields(): array
    {
        return ['type', 'status'];
    }
    public function getServiceService(): ServiceService
    {
        if (!$this->_serviceService) {
            $this->_serviceService = new ServiceService();
        }
        return $this->_serviceService;
    }
    public function getServerService(): ServerService
    {
        if (!$this->_serverService) {
            $this->_serverService = new ServerService();
        }
        return $this->_serverService;
    }
    //기본 기능부분
    //FieldForm관련용
    public function getFormOption(string $field, $options = []): array
    {
        switch ($field) {
            case 'serviceinfo_uid':
                $options = $this->getServiceService()->getEntities();
                break;
            case 'serverinfo_uid':
                $options = $this->getServerService()->getEntities();
                break;
            default:
                $options = parent::getFormOption($field, $options);
                break;
        }
        return $options;
    }
    //List 검색용
    //OrderBy 처리
    public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->getModel()->orderBy('INET_ATON(ip)', 'ASC');
        parent::setOrderBy($field, $value);
    }

    //서버파트관련 작업
    public function setServerPart(ServerPartEntity $serverPartEntity): void
    {
        $formDatas = [];
        $formDatas['clientinfo_uid']  = $serverPartEntity->getClientInfoUID();
        $formDatas['serviceinfo_uid'] = $serverPartEntity->getServiceInfoUID();
        $formDatas['serverinfo_uid']  = $serverPartEntity->getServerInfoUID();
        $formDatas['status'] = STATUS['OCCUPIED'];
        if (!array_key_exists('status', $formDatas)) {
            throw new \Exception(__METHOD__ . "에서 오류발생: CS상태가 설정되지 않았습니다.");
        }
        //CS정보가져오기
        $entity = $this->getEntity($serverPartEntity->getPartUID());
        if (!$entity instanceof CSEntity) {
            throw new \Exception("{$serverPartEntity->getPartUID()}에 해당하는 CS정보를 찾을수없습니다.");
        }
        //CS정보 수정
        parent::modify($entity, $formDatas);
    }
    public function unsetServerPart(ServerPartEntity $serverPartEntity): void
    {
        $formDatas = [];
        $formDatas['clientinfo_uid']  = null;
        $formDatas['serviceinfo_uid'] = null;
        $formDatas['serverinfo_uid']  = null;
        $formDatas['status'] = STATUS['AVAILABLE'];
        if (!array_key_exists('status', $formDatas)) {
            throw new \Exception(__METHOD__ . "에서 오류발생: CS상태가 설정되지 않았습니다.");
        }
        //CS정보가져오기
        $entity = $this->getEntity($serverPartEntity->getPartUID());
        if (!$entity instanceof CSEntity) {
            throw new \Exception("{$serverPartEntity->getPartUID()}에 해당하는 CS정보를 찾을수없습니다.");
        }
        //CS정보 수정
        parent::modify($entity, $formDatas);
    }
}
